/*
 * Licensed Materials - Property of IBM
 * com.ibm.ws.ast.samples
 *  Copyright IBM Corporation 2010. All Rights Reserved.
 * U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 * Use restricted, please refer to the "Samples Gallery" terms and conditions in the IBM International Program License Agreement.   
 */
package composite;

import org.osoa.sca.annotations.Reference;
import org.osoa.sca.annotations.Scope;
import org.osoa.sca.annotations.Service;


@Service(Source.class)
@Scope("COMPOSITE")
public class SourceImpl implements Source, SourceCallback {

    private Target targetReference;
    private Target targetReference2;

    @Reference
    public void setTargetReference(Target target) {
        this.targetReference = target;
    }

    @Reference
    public void setTargetReference2(Target target) {
        this.targetReference2 = target;
    }

    public void clientMethod(String arg) {
        System.out.println("Source: " + arg + " -> Source.clientMethod");
        targetReference.someMethod(arg + " -> Source.clientMethod");

        System.out.println("Source: " + arg + " => Source.clientMethod2");
        targetReference2.someMethod(arg + " => Source.clientMethod2");
    }

    public void receiveResult(String result) {
        System.out.println("Work thread " + Thread.currentThread());
        System.out.println("Result: " + result);
    }
}
